=begin

VS1053a plugin file converter to bin file.
Usage:
In plugin folder, execute as follows:
> ruby plg2bin.rb 
All *.plg files would be converted to *.bin files.
Plugin data are saved to *.bin files as the binary data of the little endian order with 16bit.  

Ruby version: 2.0.0p195
Windows: 7 32bit

Copyright 2013 dinau.
This file is under BSD license.

=end

Dir.glob("*.plg").each do  | plgname | 
	fin = open( plgname )
	outname = File.basename( plgname, ".plg") + ".bin"
	fout = open( outname , "w+b")
	print "\nGenerated --> #{outname}"
	state = 0
	begin
		while line = fin.gets
			case state
			when 0
				if line =~ /^const\s+.*plugin\[\]/ then 
					state = 1
				end
			when 1
				line.split(",").each do | elm | 
					str = elm.strip
					if str =~ /^0x.+/ then
						#printf("\n0x%04X", str.hex)
						fout.write( [ str.hex ].pack("S") ) # convert to 16bit little endian
					end
					if str =~ /};/ then		# end mark
						break
					end
				end
			end
		end
	ensure
		fin.close
		fout.close
	end
end

